/*******************************************************************************
 *
 *                      Hewlett-Packard Sample Code
 *
 * (c) Copyright Hewlett-Packard 1996.
 * All rights are reserved.  Copying or other
 * reproduction of this program except for archival
 * purposes is prohibited without the prior
 * written consent of Hewlett-Packard Company.
 *
 * RESTRICTED RIGHTS LEGEND
 *
 * Use, duplication, or disclosure by the U.S. Government
 * is subject to restrictions as set forth in
 * subdivision (c) (1) (ii) of the Rights in Technical
 * Data and Computer Software clause at
 * 252.227-7013.
 *
 * HEWLETT-PACKARD COMPANY
 * Palo Alto, California
 *
 ******************************************************************************/

#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <X11/extensions/shape.h>

void shapeResize(dpy, shapeWin) 
    Display *dpy;
    Window   shapeWin;
{
    XRectangle rects[1000];
    int        nRectangles = 0;

   /* The "H" */
    rects[nRectangles].x        =   0;
    rects[nRectangles].y        =   0;
    rects[nRectangles].width    =  10;
    rects[nRectangles++].height = 180;

    rects[nRectangles].x        =   0;
    rects[nRectangles].y        =  90;
    rects[nRectangles].width    = 120;
    rects[nRectangles++].height =  10;

    rects[nRectangles].x        = 120;
    rects[nRectangles].y        = 100;
    rects[nRectangles].width    =  10;
    rects[nRectangles++].height = 100;

   /* The "P" */
    rects[nRectangles].x        = 180;
    rects[nRectangles].y        =  90;
    rects[nRectangles].width    = 100;
    rects[nRectangles++].height =  10;

    rects[nRectangles].x        = 180;
    rects[nRectangles].y        =  90;
    rects[nRectangles].width    =  10;
    rects[nRectangles++].height = 180;

    rects[nRectangles].x        = 180;
    rects[nRectangles].y        = 190;
    rects[nRectangles].width    = 100;
    rects[nRectangles++].height =  10;

    rects[nRectangles].x        = 280;
    rects[nRectangles].y        = 100;
    rects[nRectangles].width    =  10;
    rects[nRectangles++].height =  90;

    XShapeCombineRectangles(dpy, shapeWin, ShapeBounding, 0, 0, 
		            rects, nRectangles, ShapeSet, Unsorted);
}

void main(argc, argv)
    int    argc; 
    char **argv;
{
    Display             *dpy;
    Window               shapeWin;
    XSetWindowAttributes shapeAttr;
    long                 shapeAttrMask;

    XEvent               event;


    dpy = XOpenDisplay( (char *)getenv("DISPLAY"));

    shapeAttr.background_pixel = WhitePixel(dpy, DefaultScreen(dpy));
    shapeAttrMask = CWBackPixel;

    shapeWin = XCreateWindow(dpy, RootWindow(dpy, DefaultScreen(dpy)),
			     100, 100, 300, 300, 0, 
			     CopyFromParent, CopyFromParent, CopyFromParent,
			     shapeAttrMask, &shapeAttr);

    XStoreName (dpy, shapeWin, "Shaped Window: HP");

    shapeResize(dpy, shapeWin);

    XSelectInput(dpy, shapeWin, StructureNotifyMask);
    XMapWindow(dpy, shapeWin);

    while(1){
	XNextEvent( dpy, &event );
	if( event.type == ConfigureNotify ){
  	    shapeResize(dpy, shapeWin);
	}
    }
}
